/******************************************************************************
 * @file     nano1xx_gpio.h
 * @brief    NANO1xx GPIO driver header file
 * @version  1.0.1
 * @date     04, September, 2012
 *
 * @note
 * Copyright (C) 2012-2014 Nuvoton Technology Corp. All rights reserved.
 ******************************************************************************/
#ifndef __NANO1XX_GPIO_H
#define __NANO1XX_GPIO_H

#include "nano1xx.h"


/** @addtogroup NANO1xx_Device_Driver NANO1xx Device Driver
  @{
*/

/** @addtogroup NANO1xx_GPIO_Driver GPIO Driver
  @{
*/

#define GPIO_PIN_ADDR(port, pin)    (*((volatile uint32_t *)((GPIOBITA_BASE+(0x40*(port))) + ((pin)<<2)))) 
#define PA0             GPIO_PIN_ADDR(0, 0) /*!< Specify P00 Pin Data Input/Output */
#define PA1             GPIO_PIN_ADDR(0, 1) /*!< Specify P01 Pin Data Input/Output */
#define PA2             GPIO_PIN_ADDR(0, 2) /*!< Specify P02 Pin Data Input/Output */
#define PA3             GPIO_PIN_ADDR(0, 3) /*!< Specify P03 Pin Data Input/Output */
#define PA4             GPIO_PIN_ADDR(0, 4) /*!< Specify P04 Pin Data Input/Output */
#define PA5             GPIO_PIN_ADDR(0, 5) /*!< Specify P05 Pin Data Input/Output */
#define PA6             GPIO_PIN_ADDR(0, 6) /*!< Specify P06 Pin Data Input/Output */
#define PA7             GPIO_PIN_ADDR(0, 7) /*!< Specify P07 Pin Data Input/Output */
#define PA8             GPIO_PIN_ADDR(0, 8) /*!< Specify P07 Pin Data Input/Output */
#define PA9             GPIO_PIN_ADDR(0, 9) /*!< Specify P07 Pin Data Input/Output */
#define PA10            GPIO_PIN_ADDR(0, 10) /*!< Specify P07 Pin Data Input/Output */
#define PA11            GPIO_PIN_ADDR(0, 11) /*!< Specify P07 Pin Data Input/Output */
#define PA12            GPIO_PIN_ADDR(0, 12) /*!< Specify P07 Pin Data Input/Output */
#define PA13            GPIO_PIN_ADDR(0, 13) /*!< Specify P07 Pin Data Input/Output */
#define PA14            GPIO_PIN_ADDR(0, 14) /*!< Specify P07 Pin Data Input/Output */
#define PA15            GPIO_PIN_ADDR(0, 15) /*!< Specify P07 Pin Data Input/Output */
#define PB0             GPIO_PIN_ADDR(1, 0) /*!< Specify P10 Pin Data Input/Output */
#define PB1             GPIO_PIN_ADDR(1, 1) /*!< Specify P11 Pin Data Input/Output */
#define PB2             GPIO_PIN_ADDR(1, 2) /*!< Specify P12 Pin Data Input/Output */
#define PB3             GPIO_PIN_ADDR(1, 3) /*!< Specify P13 Pin Data Input/Output */
#define PB4             GPIO_PIN_ADDR(1, 4) /*!< Specify P14 Pin Data Input/Output */
#define PB5             GPIO_PIN_ADDR(1, 5) /*!< Specify P15 Pin Data Input/Output */
#define PB6             GPIO_PIN_ADDR(1, 6) /*!< Specify P16 Pin Data Input/Output */
#define PB7             GPIO_PIN_ADDR(1, 7) /*!< Specify P17 Pin Data Input/Output */
#define PB8             GPIO_PIN_ADDR(1, 8) /*!< Specify P17 Pin Data Input/Output */
#define PB9             GPIO_PIN_ADDR(1, 9) /*!< Specify P17 Pin Data Input/Output */
#define PB10            GPIO_PIN_ADDR(1, 10) /*!< Specify P17 Pin Data Input/Output */
#define PB11            GPIO_PIN_ADDR(1, 11) /*!< Specify P17 Pin Data Input/Output */
#define PB12            GPIO_PIN_ADDR(1, 12) /*!< Specify P17 Pin Data Input/Output */
#define PB13            GPIO_PIN_ADDR(1, 13) /*!< Specify P17 Pin Data Input/Output */
#define PB14            GPIO_PIN_ADDR(1, 14) /*!< Specify P17 Pin Data Input/Output */
#define PB15            GPIO_PIN_ADDR(1, 15) /*!< Specify P17 Pin Data Input/Output */
#define PC0             GPIO_PIN_ADDR(2, 0) /*!< Specify P20 Pin Data Input/Output */
#define PC1             GPIO_PIN_ADDR(2, 1) /*!< Specify P21 Pin Data Input/Output */
#define PC2             GPIO_PIN_ADDR(2, 2) /*!< Specify P22 Pin Data Input/Output */
#define PC3             GPIO_PIN_ADDR(2, 3) /*!< Specify P23 Pin Data Input/Output */
#define PC4             GPIO_PIN_ADDR(2, 4) /*!< Specify P24 Pin Data Input/Output */
#define PC5             GPIO_PIN_ADDR(2, 5) /*!< Specify P25 Pin Data Input/Output */
#define PC6             GPIO_PIN_ADDR(2, 6) /*!< Specify P26 Pin Data Input/Output */
#define PC7             GPIO_PIN_ADDR(2, 7) /*!< Specify P27 Pin Data Input/Output */
#define PC8             GPIO_PIN_ADDR(2, 8) /*!< Specify P27 Pin Data Input/Output */
#define PC9             GPIO_PIN_ADDR(2, 9) /*!< Specify P27 Pin Data Input/Output */
#define PC10            GPIO_PIN_ADDR(2, 10) /*!< Specify P27 Pin Data Input/Output */
#define PC11            GPIO_PIN_ADDR(2, 11) /*!< Specify P27 Pin Data Input/Output */
#define PC12            GPIO_PIN_ADDR(2, 12) /*!< Specify P27 Pin Data Input/Output */
#define PC13            GPIO_PIN_ADDR(2, 13) /*!< Specify P27 Pin Data Input/Output */
#define PC14            GPIO_PIN_ADDR(2, 14) /*!< Specify P27 Pin Data Input/Output */
#define PC15            GPIO_PIN_ADDR(2, 15) /*!< Specify P27 Pin Data Input/Output */
#define PD0             GPIO_PIN_ADDR(3, 0) /*!< Specify P30 Pin Data Input/Output */
#define PD1             GPIO_PIN_ADDR(3, 1) /*!< Specify P31 Pin Data Input/Output */
#define PD2             GPIO_PIN_ADDR(3, 2) /*!< Specify P32 Pin Data Input/Output */
#define PD3             GPIO_PIN_ADDR(3, 3) /*!< Specify P33 Pin Data Input/Output */
#define PD4             GPIO_PIN_ADDR(3, 4) /*!< Specify P34 Pin Data Input/Output */
#define PD5             GPIO_PIN_ADDR(3, 5) /*!< Specify P35 Pin Data Input/Output */
#define PD6             GPIO_PIN_ADDR(3, 6) /*!< Specify P36 Pin Data Input/Output */
#define PD7             GPIO_PIN_ADDR(3, 7) /*!< Specify P37 Pin Data Input/Output */
#define PD8             GPIO_PIN_ADDR(3, 8) /*!< Specify P37 Pin Data Input/Output */
#define PD9             GPIO_PIN_ADDR(3, 9) /*!< Specify P37 Pin Data Input/Output */
#define PD10            GPIO_PIN_ADDR(3, 10) /*!< Specify P37 Pin Data Input/Output */
#define PD11            GPIO_PIN_ADDR(3, 11) /*!< Specify P37 Pin Data Input/Output */
#define PD12            GPIO_PIN_ADDR(3, 12) /*!< Specify P37 Pin Data Input/Output */
#define PD13            GPIO_PIN_ADDR(3, 13) /*!< Specify P37 Pin Data Input/Output */
#define PD14            GPIO_PIN_ADDR(3, 14) /*!< Specify P37 Pin Data Input/Output */
#define PD15            GPIO_PIN_ADDR(3, 15) /*!< Specify P37 Pin Data Input/Output */
#define PE0             GPIO_PIN_ADDR(4, 0) /*!< Specify P40 Pin Data Input/Output */
#define PE1             GPIO_PIN_ADDR(4, 1) /*!< Specify P41 Pin Data Input/Output */
#define PE2             GPIO_PIN_ADDR(4, 2) /*!< Specify P42 Pin Data Input/Output */
#define PE3             GPIO_PIN_ADDR(4, 3) /*!< Specify P43 Pin Data Input/Output */
#define PE4             GPIO_PIN_ADDR(4, 4) /*!< Specify P44 Pin Data Input/Output */
#define PE5             GPIO_PIN_ADDR(4, 5) /*!< Specify P45 Pin Data Input/Output */
#define PE6             GPIO_PIN_ADDR(4, 6) /*!< Specify P46 Pin Data Input/Output */
#define PE7             GPIO_PIN_ADDR(4, 7) /*!< Specify P47 Pin Data Input/Output */
#define PE8             GPIO_PIN_ADDR(4, 8) /*!< Specify P47 Pin Data Input/Output */
#define PE9             GPIO_PIN_ADDR(4, 9) /*!< Specify P47 Pin Data Input/Output */
#define PE10            GPIO_PIN_ADDR(4, 10) /*!< Specify P47 Pin Data Input/Output */
#define PE11            GPIO_PIN_ADDR(4, 11) /*!< Specify P47 Pin Data Input/Output */
#define PE12            GPIO_PIN_ADDR(4, 12) /*!< Specify P47 Pin Data Input/Output */
#define PE13            GPIO_PIN_ADDR(4, 13) /*!< Specify P47 Pin Data Input/Output */
#define PE14            GPIO_PIN_ADDR(4, 14) /*!< Specify P47 Pin Data Input/Output */
#define PE15            GPIO_PIN_ADDR(4, 15) /*!< Specify P47 Pin Data Input/Output */
#define PF0             GPIO_PIN_ADDR(5, 0) /*!< Specify P50 Pin Data Input/Output */
#define PF1             GPIO_PIN_ADDR(5, 1) /*!< Specify P51 Pin Data Input/Output */
#define PF2             GPIO_PIN_ADDR(5, 2) /*!< Specify P52 Pin Data Input/Output */
#define PF3             GPIO_PIN_ADDR(5, 3) /*!< Specify P53 Pin Data Input/Output */
#define PF4             GPIO_PIN_ADDR(5, 4) /*!< Specify P54 Pin Data Input/Output */
#define PF5             GPIO_PIN_ADDR(5, 5) /*!< Specify P55 Pin Data Input/Output */


/******************************************************************************/
/*                GPIO Specific inline                                        */
/******************************************************************************/
/** @addtogroup NANO1xx_GPIO_EXPORTED_FUNCTIONS GPIO Exported Functions
  @{
*/

/**   
  * @brief  GPIO Initial, Enable clock.
  * @param  None.
  * @retval None.
  */
static __INLINE void GPIO_Init()
{
	CLK->AHBCLK |= CLK_AHBCLK_GPIO_EN;
}

/**   
  * @brief  GPIO DeInit, Disable clock.
  * @param  None.
  * @retval None.
  */
static __INLINE void GPIO_DeInit()
{
	CLK->AHBCLK &= ~CLK_AHBCLK_GPIO_EN;
}

/**   
  * @brief  GPIO Open, Specific GPIO bit operation mode.
  * @param  port: specific GPIO port, GPIOA ~ GPIOF.
  * @param  mode: specific operation mode
  * @param  mask: operation mode mask.
  * @retval None.
  */
static __INLINE void GPIO_Open(GPIO_TypeDef *port, uint32_t mode, uint32_t mask)
{
	port->PMD = (port->PMD & ~mask | mode);
}

/**   
  * @brief  GPIO Close, Close specific GPIO bit.
  * @param  port: specific GPIO port, GPIOA ~ GPIOF.
  * @param  bit : specific bit of GPIO port, 0 ~ 15.
  * @retval None.
  */
static __INLINE void GPIO_Close(GPIO_TypeDef *port, uint32_t bit)
{
	port->PMD &= ~(0x3<<(bit<<1));
}

/**   
  * @brief  GPIO_SetBit, Set the specified GPIO pin to 1.
  * @param  port: specific GPIO port, GPIOA ~ GPIOF.
  * @param  bit : specific bit of GPIO port, 0 ~ 15.
  * @retval None.
  */
static __INLINE void GPIO_SetBit(GPIO_TypeDef *port, uint32_t bit)
{
	port->DOUT |= (1 << bit);
}

/**   
  * @brief  GPIO_GetBit, Get the pin value from the specified input GPIO pin.
  * @param  port: specific GPIO port, GPIOA ~ GPIOF.
  * @param  bit : specific bit of GPIO port, 0 ~ 15.
  * @retval The specified input pin value.
  */
static __INLINE uint32_t GPIO_GetBit(GPIO_TypeDef *port, uint32_t bit)
{
	return ((port->PIN >> bit) & 0x1);
}

/**   
  * @brief  GPIO_ClrBit, Set the specific GPIO pin to 0.
  * @param  port: specific GPIO port, GPIOA ~ GPIOF.
  * @param  bit : specific bit of GPIO port, 0 ~ 15.
  * @retval None.
  */
static __INLINE void GPIO_ClrBit(GPIO_TypeDef *port, uint32_t bit)
{
	port->DOUT &= ~(1 << bit);
}

/**   
  * @brief  GPIO_SetPortBits, Set output value to the specified GPIO port.
  * @param  port: specific GPIO port, GPIOA ~ GPIOF.
  * @param  data: The data output value. It could be 0~0xFFFF.
  * @retval None.
  */
static __INLINE void GPIO_SetPortBits(GPIO_TypeDef *port, uint32_t data)
{
	port->DOUT = data;
}

/**   
  * @brief  GPIO_GetPortBits, Get the input port value from the specified GPIO port.
  * @param  port: specific GPIO port, GPIOA ~ GPIOF.
  * @retval The specified input port value.
  */
static __INLINE uint32_t GPIO_GetPortBits(GPIO_TypeDef *port)
{
	return (port->PIN);
}

/**   
  * @brief  GPIO_GetDoutBit, Get the bit value from the specified Data Output Value Register.
  * @param  port: specific GPIO port, GPIOA ~ GPIOF.
  * @param  bit : specific bit of GPIO port, 0 ~ 15.
  * @retval The bit value of the specified register.
  */
static __INLINE uint32_t GPIO_GetDoutBit(GPIO_TypeDef *port, uint32_t bit)
{
	return ((port->DOUT >> bit) & 0x1);
}

/**   
  * @brief  GPIO_GetPortDoutBits, Get the port value from the specified Data Output Value Register.
  * @param  port: specific GPIO port, GPIOA ~ GPIOF.
  * @retval The portt value of the specified register.
  */
static __INLINE uint32_t GPIO_GetPortDoutBits(GPIO_TypeDef *port)
{
	return (port->DOUT);
}

/**   
  * @brief  GPIO_SetBitMask, This function is used to protect the write data function of the 
  *         corresponding GPIO pin. When set the bit mask, the write signal is masked and write 
  *         data to the protect bit is ignored.
  * @param  port: specific GPIO port, GPIOA ~ GPIOF.
  * @param  bit : specific bit of GPIO port, 0 ~ 15.
  * @retval None.
  */
static __INLINE void GPIO_SetBitMask(GPIO_TypeDef *port, uint32_t bit)
{
	port->DMASK |= (1 << bit);
}

/**   
  * @brief  GPIO_GetBitMask, Get the bit value from the specified Data Output Write Mask Register 
  *         If the bit value is 1, it's meaning the corresponding bit is protected. 
  *         And write data to the bit is ignored.
  * @param  port: specific GPIO port, GPIOA ~ GPIOF.
  * @param  bit : specific bit of GPIO port, 0 ~ 15.
  * @retval The bit value of the specified register.
  */
static __INLINE uint32_t GPIO_GetBitMask(GPIO_TypeDef *port, uint32_t bit)
{
	return ((port->DMASK >> bit) & 0x1);
}

/**   
  * @brief  GPIO_ClrBitMask, This function is used to remove the write protect function of the the 
  *         corresponding GPIO pin. After remove the bit mask, write  data to the 
  *         corresponding bit is workable.
  * @param  port: specific GPIO port, GPIOA ~ GPIOF.
  * @param  bit : specific bit of GPIO port, 0 ~ 15.
  * @retval None.
  */
static __INLINE void GPIO_ClrBitMask(GPIO_TypeDef *port, uint32_t bit)
{
	port->DMASK &= ~(1 << bit);
}

/**   
  * @brief  GPIO_SetPortMask, This function is used to protect the write data function of the 
  *         corresponding GPIO pin. When set the bits are masked, write data to the protect 
  *          bits are ignored.
  * @param  port: specific GPIO port, GPIOA ~ GPIOF.
  * @param  data: Specify pins of the GPIO port. It could be 0~0xFFFF.
  * @retval None.
  */
static __INLINE void GPIO_SetPortMask(GPIO_TypeDef *port, uint32_t data)
{
	port->DMASK |= data;
}

/**   
  * @brief  GPIO_GetPortMask, Get the port value from the specified Data Output Write Mask Register. 
  *         If the bit value is 1, it's meaning the corresponding bit is protected. 
  *         And write data to the bit is ignored.
  * @param  port: specific GPIO port, GPIOA ~ GPIOF.
  * @retval The port value of the specified register.
  */
static __INLINE uint32_t GPIO_GetPortMask(GPIO_TypeDef *port)
{
	return (port->DMASK);
}

/**   
  * @brief  GPIO_ClrPortMask, This function is used to remove the write protect function of the the 
  *         corresponding GPIO pin. After remove the bit mask, write  data to the 
  *         corresponding bit is workable.
  * @param  port: specific GPIO port, GPIOA ~ GPIOF.
  * @param  data: Specify pins of the GPIO port. It could be 0~0xFFFF.
  * @retval None.
  */
static __INLINE void GPIO_ClrPortMask(GPIO_TypeDef *port, uint32_t data)
{
	port->DMASK &= ~data;
}

/**   
  * @brief  GPIO_EnablePullup, Enable the pullup resistor of the specified GPIO input pin. 
  * @param  port: specific GPIO port, GPIOA ~ GPIOF.
  * @param  bit : specific bit of GPIO port, 0 ~ 15.
  * @retval None.
  */
static __INLINE void GPIO_EnablePullup(GPIO_TypeDef *port, uint32_t bit)
{
	port->PUEN |= (1 << bit);
}

/**   
  * @brief  GPIO_DisablePullup, Disable the pullup resistor of the specified GPIO input pin. 
  * @param  port: specific GPIO port, GPIOA ~ GPIOF.
  * @param  bit : specific bit of GPIO port, 0 ~ 15.
  * @retval None.
  */
static __INLINE void GPIO_DisablePullup(GPIO_TypeDef *port, uint32_t bit)
{
	port->PUEN &= ~(1 << bit);
}

/**   
  * @brief  GPIO_EnableDebounce, Enable the debounce function of the specified GPIO input pin. 
  * @param  port: specific GPIO port, GPIOA ~ GPIOF.
  * @param  bit : specific bit of GPIO port, 0 ~ 15.
  * @retval None.
  */
static __INLINE void GPIO_EnableDebounce(GPIO_TypeDef *port, uint32_t bit)
{
	GPIODBNCE->CON |= GPIO_DBNCECON_ICLK_ON;
	port->DBEN |= (1 << bit);
}

/**   
  * @brief  GPIO_DisableDebounce, Disable the debounce function of the specified GPIO input pin. 
  * @param  port: specific GPIO port, GPIOA ~ GPIOF.
  * @param  bit : specific bit of GPIO port, 0 ~ 15.
  * @retval None.
  */
static __INLINE void GPIO_DisableDebounce(GPIO_TypeDef *port, uint32_t bit)
{
	port->DBEN &= ~(1 << bit);
}

/**   
  * @brief  GPIO_SetDebounceTime, Set the interrupt debounce sampling time
  *         based on the debounce counter clock source. 
  * @param  CycleSelection: The number of sampling cycle selection.
  * @param  ClockSource   : HCLK or 10K.
  * @retval None.
  */
static __INLINE void GPIO_SetDebounceTime(uint32_t CycleSelection, uint32_t ClockSource)
{
	GPIODBNCE->CON |= (CycleSelection|ClockSource) ;
}

/**   
  * @brief  GPIO_GetDebounceSampleCycle, This function is used to get the number
  *         of debounce sampling cycle selection. 
  * @param  None.
  * @retval Number of the sampling cycle selection.
  */
static __INLINE uint32_t GPIO_GetDebounceSampleCycle()
{
	return (GPIODBNCE->CON & GPIO_DBNCECON_DBCLKSEL_MASK);
}

/**   
  * @brief  GPIO_GetIntStatus, Get the port value from the specified Interrupt Trigger Source  
  *         Indicator Register. If the corresponding bit of the return port value is 1, it's meaning the 
  *         interrupt occurred at the corresponding bit. Otherwise, no interrupt occurred at that bit.
  * @param  port: specific GPIO port, GPIOA ~ GPIOF.
  * @retval The portt value of the specified register.
  */
static __INLINE uint32_t GPIO_GetIntStatus(GPIO_TypeDef *port)
{
	return (port->ISR);
}

/*------------------------------------------------------------*/
void GPIO_EnableInt(GPIO_TypeDef *port, uint32_t bit, uint32_t TriggerType, uint32_t Mode);
void GPIO_DisableInt(GPIO_TypeDef *port, uint32_t bit);
void GPIO_EnableEINT0(GPIO_TypeDef *port, uint32_t bit, uint32_t TriggerType, uint32_t Mode);
void GPIO_DisableEINT0(GPIO_TypeDef *port, uint32_t bit);
void GPIO_EnableEINT1(GPIO_TypeDef *port, uint32_t bit, uint32_t TriggerType, uint32_t Mode);
void GPIO_DisableEINT1(GPIO_TypeDef *port, uint32_t bit);

/*@}*/ /* end of group NANO1xx_GPIO_EXPORTED_FUNCTIONS */

/*@}*/ /* end of group NANO1xx_GPIO_Driver */

/*@}*/ /* end of group NANO1xx_Device_Driver */

#endif

/*** (C) COPYRIGHT 2012 Nuvoton Technology Corp. ***/







